# Bloom Filter Generator
Allows the creation of a bloom filter based on a data set.

Also allows checking if an address is in the filter.


The input data set should be `/n` delineated `.txt` file that looks something like:
```
firstaddress
secondaddress
thirdaddress
```

The resulting bloom filter can be "checked against" with an address, and will respond whether that address exists in the bloom filter set or not.

It's important to keep in mind that bloom filters are probabilistic data structures and as such result in false positives usually at a rate of ~1%, which can be adjusted for by increasing the data set size, but at typical parameters which result from an optimized bloom filter, balancing false positives and size, 1% is the usual rate we encounter.

## Generate bloom filter
`python bloom-util.py create --filter_file filter.pkl --addresses_file addresses.txt`

## Check if address is in bloom filter
`python bloom-util.py check --filter_file filter.pkl --address firstaddress`

$ Address firstaddress is in the filter

`python bloom-util.py check --filter_file filter.pkl --address fourthaddress`

$ Address fourthaddress is not in the filter

## Status

This is experimental, unmaintained code. Use only as research inspiration.

## License

Licensed under either of `Apache License, Version 2.0` or `MIT` license at your option.

## Credits

Written by Anton Livaja, improved by Christian Reitter.